//+------------------------------------------------------------------+
//|                                      Difference Distribution.mq5 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property script_show_inputs

#include <Graphics\Graphic.mqh> CGraphic c_graphic;

input ushort Length=14,
             Level=500,
             ViewDuration=5;
input bool ScreenShot=false;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   int array[][2],size=0;
   double weight[];
   ArrayResize(weight,Length);
   ArrayInitialize(weight,-1.0/Length);
   weight[0]=weight[0]+1;

   for(int i=iBars(_Symbol,PERIOD_CURRENT)-Length-1; i>0; i--)
     {
      double sum=0;
      for(int j=0; j<Length; j++)
         sum=sum+weight[j]*iClose(_Symbol,PERIOD_CURRENT,i+j);

      int res=(int)MathRound(sum/_Point);

      if(Level>=-res && res<=Level && res!=0)
        {
         int index=ArrayBsearch(array,res);

         if(index>=0 && array[index][0]==res)
            array[index][1]++;
         else
           {
            ArrayResize(array,size+1);
            array[size][0]=res;
            array[size][1]=1;
            size++;
            ArraySort(array);
           }
        }
     }
//---
   double x[],y[];
   ArrayResize(x,size);
   ArrayResize(y,size);

   for(int i=0; i<size; i++)
     {
      x[i]=array[i][0];
      y[i]=array[i][1];
     }
//---
   ChartSetInteger(0,CHART_SHOW,false);
   int w=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),
       h=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
   c_graphic.Create(0,"Graphic",0,0,0,w,h);
   c_graphic.CurveAdd(x,y,CURVE_LINES).LinesWidth(2);
   c_graphic.CurvePlotAll();
   c_graphic.Update();
   if(ScreenShot==true)
      ChartScreenShot(0,"DifferenceDistribution.png",w,h);
   Sleep(ViewDuration*1000);
   c_graphic.Destroy();
   ChartSetInteger(0,CHART_SHOW,true);
//---
  }
//+------------------------------------------------------------------+
